unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, PS, ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    PS1: TPS;
    GroupBox1: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PS1UserFunction(const Name: String;
      var Declare: String; var ProcPtr: Pointer);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Memo1Enter(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Memo1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }

    procedure CursorPosition();
    function GetLine(Pos: Integer): Integer;
    procedure ScrollMemo(Line: Integer);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses richedit;

{$R *.DFM}


function MyFunction (x: Double): Double;
begin
  Result:= Sqrt(x);
end;

procedure MsgBox (s: String);
begin
  ShowMessage(s);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if PS1.Active then PS1.DeActivate;
  PS1.Script.Text:= Memo1.Text;
  Label1.Caption:= '';
  try
    PS1.Activate;
    GroupBox1.Enabled:= PS1.Active;
    StatusBar1.Panels[1].Text:= '   !';
  except
    on E: Exception do
    begin
      ShowMessage(e.Message);
      StatusBar1.Panels[1].Text:= PS1.ErrMsg + '  [pos - ' +
                                  IntToStr(PS1.ErrLine) +  ' / ' +
                                  IntToStr(PS1.ErrPos) + ']';
      ScrollMemo(PS1.ErrLine);
      Memo1.SelStart:= PS1.ErrPos;
      Memo1.SetFocus;
    end;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  PS1.DeActivate;
  GroupBox1.Enabled:= PS1.Active;
  Label1.Caption:= '';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Text:= PS1.Script.Text;
  PS1.SetFunction('Function MyFunction(x: Double):Double', 'MyFunction', @MyFunction);
end;

procedure TForm1.PS1UserFunction(const Name: String;
  var Declare: String; var ProcPtr: Pointer);
begin
  if Name = 'MSGBOX' then
  begin
    Declare:= 'Procedure MsgBox(s: String)';
    ProcPtr:= @MsgBox;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  PS1.VarName:= 'd';
  Label1.Caption:= 'd  =  ' + PS1.VarValue;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  s: String;

begin
  s:= 'i  =  ' + IntToStr(PS1.VarByName('i'));
  Label1.Caption:= s;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  i: Integer;
  s: String;

begin
  s:= '';
  for i := 0 to PS1.VarCount - 1 do
  begin
    s:= s + PS1.VarList[i].Name + ' = ' +
        string(PS1.VarList[i].Value) + #13;
  end;
  Label1.Caption:= Trim(s);
end;

procedure TForm1.CursorPosition;
begin
  StatusBar1.Panels[0].Text:= IntToStr(GetLine(Memo1.SelStart)) +
                              ' / ' + IntToStr(Memo1.SelStart);
end;

procedure TForm1.Memo1Enter(Sender: TObject);
begin
  CursorPosition();
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  CursorPosition();
end;

procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
  CursorPosition();
end;

procedure TForm1.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  CursorPosition();
end;

procedure TForm1.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  CursorPosition();
end;

procedure TForm1.Memo1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  CursorPosition();
end;

function TForm1.GetLine(Pos: Integer): Integer;
var
  i: Integer;
  s: String;
begin
  Result:= 1;
  s:= Memo1.Text;
  for i := 0 to Pos do
    if s[i] = #13 then
      inc(Result);
end;

procedure TForm1.ScrollMemo(Line: Integer);
begin
  Memo1.Perform(EM_LINESCROLL, 0, Line);
end;


end.
