unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, PS, ComCtrls,
  SynEditHighlighter, SynHighlighterPas, SynEdit;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PS1: TPS;
    GroupBox1: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    CheckBox1: TCheckBox;
    SynEdit1: TSynEdit;
    Pas: TSynPasSyn;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PS1UserFunction(const Name: String;
      var Declare: String; var ProcPtr: Pointer);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SynEdit1Enter(Sender: TObject);
    procedure SynEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure SynEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SynEdit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }

    procedure CursorPosition();
    procedure ScrollMemo(Line: Integer);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


function MyFunction (x: Double): Double;
begin
  Result:= Sqrt(x);
end;

procedure MsgBox (s: String);
begin
  ShowMessage(s);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if PS1.Active then PS1.DeActivate;
  PS1.Script.Text:= SynEdit1.Lines.Text;
  Label1.Caption:= '';
  try
    PS1.Activate;
    GroupBox1.Enabled:= PS1.Active;
    StatusBar1.Panels[1].Text:= '   !';
  except
    on E: Exception do
    begin
      ShowMessage(e.Message);
      StatusBar1.Panels[1].Text:= PS1.ErrMsg + '  [pos - ' +
                                  IntToStr(PS1.ErrLine) +  ' / ' +
                                  IntToStr(PS1.ErrPos) + ']';
      ScrollMemo(PS1.ErrLine);
      SynEdit1.SelStart:= PS1.ErrPos;
      SynEdit1.SetFocus;
    end;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  PS1.DeActivate;
  GroupBox1.Enabled:= PS1.Active;
  Label1.Caption:= '';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SynEdit1.Lines.Text:= PS1.Script.Text;
  CheckBox1.Checked:= True;
  PS1.SetFunction('Function MyFunction(x: Double):Double', 'MyFunction', @MyFunction);
end;

procedure TForm1.PS1UserFunction(const Name: String;
  var Declare: String; var ProcPtr: Pointer);
begin
  if Name = 'MSGBOX' then
  begin
    Declare:= 'Procedure MsgBox(s: String)';
    ProcPtr:= @MsgBox;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  PS1.VarName:= 'd';
  Label1.Caption:= 'd  =  ' + PS1.VarValue;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  s: String;

begin
  s:= 'i  =  ' + IntToStr(PS1.VarByName('i'));
  Label1.Caption:= s;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  i: Integer;
  s: String;

begin
  s:= '';
  for i := 0 to PS1.VarCount - 1 do
  begin
    s:= s + PS1.VarList[i].Name + ' = ' +
        string(PS1.VarList[i].Value) + #13;
  end;
  Label1.Caption:= Trim(s);
end;

procedure TForm1.CursorPosition;
begin
  StatusBar1.Panels[0].Text:= IntToStr(SynEdit1.CaretY) +
                              ' / ' + IntToStr(SynEdit1.CaretX) +
                              ' / ' + IntToStr(SynEdit1.SelStart);
end;


procedure TForm1.ScrollMemo(Line: Integer);
begin
  SynEdit1.Perform(EM_LINESCROLL, 0, Line);
end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    SynEdit1.Highlighter:= Pas
  else
    SynEdit1.Highlighter:= Nil;
end;

procedure TForm1.SynEdit1Enter(Sender: TObject);
begin
  CursorPosition();
end;

procedure TForm1.SynEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  CursorPosition();
end;

procedure TForm1.SynEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  CursorPosition();
end;

procedure TForm1.SynEdit1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  CursorPosition();
end;

end.
