unit ListUserFunc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGridEh, DBGrids, StdCtrls, Buttons, Db, DBClient, ps;

type
  TfListUserFunc = class(TForm)
    Grid: TDBGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    clnFunc: TClientDataSet;
    dsFunc: TDataSource;
    clnFuncSubFunc: TStringField;
    clnFuncName: TStringField;
    clnFuncDeclare: TStringField;
    clnFuncDescript: TStringField;
    procedure clnFuncAfterScroll(DataSet: TDataSet);
    procedure GridKeyPress(Sender: TObject; var Key: Char);
  private
    FFunctionName: String;
    procedure SetFunctionName(const Value: String);
  private
    PS: TPS;
    { Private declarations }
    procedure FillCln(FuncName: String);
    property FunctionName: String read FFunctionName write SetFunctionName;
  public
    { Public declarations }
  end;

var
  fListUserFunc: TfListUserFunc;

  Function GetFuncName(Ps: TPS; var FuncName: String;
                       Left: Integer = 0 ; Top: Integer = 0): Boolean;

implementation

uses
  strtools;
{$R *.DFM}

Function GetFuncName;
begin
  try
    fListUserFunc:= TfListUserFunc.Create(Application);
    fListUserFunc.PS:= Ps;
    fListUserFunc.FillCln(FuncName);
    if (Left > 0) then fListUserFunc.Left:= Left;
    if (Top > 0) then fListUserFunc.Top:= Top;
    Result:= (fListUserFunc.ShowModal = mrOk);
    if Result then
      FuncName:= Trim(fListUserFunc.clnFuncName.AsString)
    else
      FuncName:= '';
  finally
    FreeAndNil(fListUserFunc);
  end;
end;

{ TfListUserFunc }

procedure TfListUserFunc.FillCln;
var
  i: Integer;
  s: String;
begin
  clnFunc.Close;
  clnFunc.CreateDataSet;
  clnFunc.Open;
  clnFunc.DisableControls;
  FuncName:= Trim(FuncName);
  for i:= 0 to PS.ListUserFuction.Count - 1 do
  begin
    s:= PS.ListUserFuction.Strings[i];
    clnFunc.Append;
    clnFuncName.AsString:= Token(s, '*', 1);
    clnFuncDeclare.AsString:= Token(s, '*', 2);
    clnFuncDescript.AsString:= Token(s, '*', 3);
    clnFuncSubFunc.AsString:= Token(Token(s, '*', 2), ' ', 1);
    clnFunc.Post;
  end;
  clnFunc.First;
  clnFunc.EnableControls;
  FunctionName:= FuncName;
end;

procedure TfListUserFunc.clnFuncAfterScroll(DataSet: TDataSet);
begin
  Grid.Hint:= Trim(clnFuncDeclare.AsString);
end;

procedure TfListUserFunc.SetFunctionName(const Value: String);
begin
  if FFunctionName = Value then exit;
  FFunctionName := Value;
  if Value = '' then
    clnFunc.First
  else
    clnFunc.Locate('Name', Value, [loCaseInsensitive, loPartialKey]);
end;

procedure TfListUserFunc.GridKeyPress(Sender: TObject; var Key: Char);
begin
  FunctionName:= FunctionName + Key;
end;

end.
