unit strtools;

interface
const
  //    Token
  DefaultSeparators=' ';
  MSDOS_FILENAME_SYMBOLS='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_$#&@!%(){}~^';
  WINDOWS_FILENAME_SYMBOLS=' ŨabcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_$#&@!%(){}~^';
  ADVANTAGE_FILENAME_SYMBOLS=' abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_$#&@!%(){}~^';
  RUSSIAN_SYMBOLS=' Ũ';
  ENGLISH_SYMBOLS=' abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
  DIGIT_SYMBOLS='0123456789';
type
  TIntegerSequence=array of Integer;
  TTokenInfo=Record
    Pos: Integer; //     
    Len: Integer; //  
  end;
  TTextInfo=Class(TObject)
  private
    FText      : String; //  
    FSeparators: String; //  
    FTokenCount: Integer;//    
    FSeparatorCount:Integer;//    
    FTokenInfo : array of TTokenInfo;
    procedure SetText(const Value: String);
    procedure SetSeparators(const Value: String);
    procedure FillTokenInfo;
    function GetTokenInfo(Index: Integer): TTokenInfo;
    function GetStrings(Index: Integer): String;
  public
    property Strings[Index: Integer]: String read GetStrings;
    property TokenCount:Integer read FTokenCount;
    property TokenInfo[Index: Integer]: TTokenInfo read GetTokenInfo;
    property Text:String read FText write SetText;
    property Separators:String read FSeparators write SetSeparators;
    constructor Create(Const Text:String;Const Separators:String=DefaultSeparators;SeparatorCount:Integer=1);
    destructor Destroy; override;
  end;

    //   InputStr  ,
    //   Separators,     
    function Token(InputStr:String;Separators:String=DefaultSeparators;WordIndex:Integer=0;SeparatorCount:Integer=1):String;
    // NumToken      InputStr  ,
    //   Separators
    function NumToken(InputStr:String;Separators:String=DefaultSeparators;SeparatorCount:Integer=1):Integer;
    // ATToken        InputStr  ,
    //   Separators
    function ATToken(InputStr:String;Separators:String=DefaultSeparators;WordIndex:Integer=0):Integer;
    //    -  Windows 
    Function GetAnsiString(oemS: String):String;
    //   Win -  DOS 
    function GetOEMString(AnsiString: String):String;
    //   
    Function PadR(S: String; Len: Integer;cChar:Char=' '): String ;
    //   
    Function PadL(S: String; Len: Integer;cChar:Char=' '): String ;
    //      .
    Function SmartString (cStr: String): String ;
    //     
    function CorrectPath(Path:String):String;
    //    
    procedure IncStr(var MyString:String);
    //    
    procedure DecStr(var MyString:String);
    //  HEX   
    procedure IncHex(var MyString:String);
    //  HEX   
    procedure DecHex(var MyString:String);
    //      
    function UpAndTrim(MyString:String):String;
    //       
    //    
    function CheckInvalidSymbols(InputString:String;
                                 ValidSymbols:String;
                                 InvalidSymbols:String=''):Integer;
    //   ResultLen,   Symbol
    function ReplicateChar(ResultLen:Integer;Symbol:Char):String;
    //
    function GetTagName(DBFName: String; TagNo: Integer): String;
    //
    function GetTemplateName(DBFName:String):String;
    //    
    Function Right(cString: String; nCount: Integer): String;
    //   
    Function FormatTelephone(Telephon: String): String;
    //    
    function RemoveChars(AString:String;Symbol:Char=' '):String;
    //    ,  
    function FilterStringInc(FilteredString:String;CharSequence:String='0123456789'):String;
    //   AString  SubString
    function DeleteSubString(AString:String;SubString:String;NoCase:Boolean=True):String;
    //    1-5,8,10,20-25  ..  
    function GetIntegerSequence(SequenceString:String):TIntegerSequence;
    //    
    function ReplaceChar(S: String; NewChar, OldChar: PChar): String;
    //  
    function ReverceString(InputString:String):String;
//
implementation

//********************
uses SysUtils, Windows, Classes, NumTools;
//********************

// Token    InputStr  ,
    //    Separators,    WordIndex
    // , , .
    // InputStr     ,
    //   .
    // WordIndex ,     ,     
    // WordIndex=0,  -    
    // -   
function Token(InputStr:String;Separators:String=DefaultSeparators;WordIndex:Integer=0;SeparatorCount:Integer=1):String;
var
  MyTextInfo:TTextInfo;
begin
  MyTextInfo:=TTextInfo.Create(InputStr,Separators,SeparatorCount);
  try
    if MyTextInfo.TokenCount=0 then Result:=''
    else if WordIndex=0 then Result:=MyTextInfo.Strings[MyTextInfo.TokenCount]
    else if WordIndex>MyTextInfo.TokenCount then Result:=''
    else Result:=MyTextInfo.Strings[WordIndex];
  finally
    MyTextInfo.Destroy;
  end;
end;
//*****************************
// NumToken      InputStr  ,
    //   Separators
function NumToken(InputStr:String;Separators:String=DefaultSeparators;SeparatorCount:Integer=1):Integer;
var
  MyTextInfo:TTextInfo;
begin
  MyTextInfo:=TTextInfo.Create(InputStr,Separators,SeparatorCount);
  try
    Result:=MyTextInfo.TokenCount;
  finally
    MyTextInfo.Destroy;
  end;
end;
//*****************************
function ATToken(InputStr:String;Separators:String=DefaultSeparators;WordIndex:Integer=0):Integer;
var
  MyTextInfo:TTextInfo;
begin
  MyTextInfo:=TTextInfo.Create(InputStr,Separators);
  try
    if MyTextInfo.TokenCount=0 then Result:=0
    else if WordIndex=0 then Result:=MyTextInfo.TokenInfo[MyTextInfo.TokenCount].Pos
    else if WordIndex>MyTextInfo.TokenCount then Result:=0
    else Result:=MyTextInfo.TokenInfo[WordIndex].Pos;
  finally
    MyTextInfo.Destroy;
  end;
end;
//*****************************
{ TTextInfo }
//*****************************
procedure TTextInfo.FillTokenInfo;
var
  nWordNum:Integer;  //  
  i:Integer;         //    
  nWordLen:Integer;  //  
  nSepCount:Integer;
begin
  nWordNum:=0;
  nWordLen:=0;
  nSepCount:=0;
  SetLength(FTokenInfo,0);
  for i:=1 to Length(FText) do
  begin
    if Pos(FText[i],FSeparators)>0 then
    begin
      nWordLen:=0;
      if FSeparatorCount > 0 then
      begin
        Inc(nSepCount,1);
        if (nSepCount > FSeparatorCount) or
           ((nWordNum = 0) and (nSepCount = FSeparatorCount)) then
        begin
          Inc(nWordNum,1);
          SetLength(FTokenInfo,nWordNum);
          FTokenInfo[nWordNum-1].Pos:=i;
          FTokenInfo[nWordNum-1].Len:=0;
        end;
      end;
    end
    else begin
      nSepCount:=0;
      Inc(nWordLen);
      if nWordLen=1 then
      begin
        Inc(nWordNum);
        SetLength(FTokenInfo,nWordNum);
        FTokenInfo[nWordNum-1].Pos:=i;
      end;
      FTokenInfo[nWordNum-1].Len:=nWordLen;
    end;
  end;
  FTokenCount:=nWordNum;
end;
//*****************************
constructor TTextInfo.Create(Const Text:String;Const Separators:String=DefaultSeparators;SeparatorCount:Integer=1);
begin
  inherited Create;
  FText:=Text;
  FSeparators:=Separators;
  FSeparatorCount:=SeparatorCount;
  FillTokenInfo;
end;
//*****************************
destructor TTextInfo.Destroy;
begin
  FText:='';
  SetLength(FTokenInfo,0);
  inherited Destroy;
end;
//*****************************
procedure TTextInfo.SetText(const Value: String);
begin
  FText := Value;
  FillTokenInfo;
end;

//*****************************
procedure TTextInfo.SetSeparators(const Value: String);
begin
  FSeparators := Value;
  FillTokenInfo;
end;

//*****************************
function TTextInfo.GetTokenInfo(Index: Integer): TTokenInfo;
begin
  Result:=FTokenInfo[Index-1];
end;


//*****************************
function TTextInfo.GetStrings(Index: Integer): String;
begin
  Result:= '';
  if TokenInfo[Index].Len > 0 then
    Result:=Copy(Text,TokenInfo[Index].Pos,TokenInfo[Index].Len);
end;


//*****************************
Function PadR;
var
  OldLen: Integer;
begin
  Result:= S;
  SetLength(Result, Len);
  OldLen:= Length(S);
  if OldLen < Len then
    FillChar(Result[OldLen+1], Len-OldLen, cChar);
end;


//*****************************
Function PadL;
var
  OldLen: Integer;
  FillStr:String;
begin
  Result:= S;
  OldLen:= Length(S);
  if OldLen < Len then
  begin
    SetLength(FillStr,Len-OldLen);
    FillChar(FillStr[1], Len-OldLen, cChar);
    Result:=FillStr+Result;
  end
  else SetLength(Result,Len);
end;


//******************
Function SmartString;
begin
  Result:= '';
  if Length(cStr)>0 then
  Result:= AnsiUpperCase(cStr[1])+
           AnsiLowerCase(Copy(cStr,2,Length(cStr)-1));
  Result:= Trim(Result);         
end;


//********************
Function GetAnsiString;
begin
  Result:= '';
  if Trim(oemS) = '' then exit;
  SetLength(Result,Length(oemS));
  OemToAnsi(PChar(oemS),PChar(Result));
end;

//********************
function GetOEMString(AnsiString: String):String;
begin
  Result:= '';
  if Trim(AnsiString) = '' then exit;
  SetLength(Result,Length(AnsiString));
  CharToOem(PChar(AnsiString),PChar(Result));
end;
//********************
function CorrectPath(Path:String):String;
var
  PathLen:Integer;
begin
  repeat
    PathLen:=Length(Path);
    if (PathLen>0) and (Path[PathLen] in ['/','\']) then SetLength(Path,PathLen-1)
    else Break;
  until (PathLen=0);
  Result:=UpAndTrim(Path);
end;


//********************
procedure IncStr(var MyString:String);
const
  FIRST_CHAR_CODE=32;
  LAST_CHAR_CODE=255;
var
  i:Integer;
begin
  for i:= Length(MyString) downto 1 do
  begin
    if MyString[i]=Chr(LAST_CHAR_CODE)
    then MyString[i]:=Chr(FIRST_CHAR_CODE)
    else begin
      MyString[i]:=Succ(MyString[i]);
      Break;
    end;
  end;
end;


//**********************************
procedure DecStr(var MyString:String);
begin
//
end;

//**********************************
procedure IncHex(var MyString:String);
const
  CHAR_SEQUENCE='0123456789ABCDEF';
var
  i:Integer;
begin
  MyString:=AnsiUpperCase(MyString);
  for i:= Length(MyString) downto 1 do
  begin
    if MyString[i]='F'
    then MyString[i]:='0'
    else begin
      MyString[i]:=Copy(CHAR_SEQUENCE,Pos(MyString[i],CHAR_SEQUENCE)+1,1)[1];
      Break;
    end;
  end;
end;


//**********************************
procedure DecHex(var MyString:String);
begin
//
end;

//**********************************
function UpAndTrim(MyString:String):String;
begin
  Result:=AnsiUpperCase(Trim(MyString));
end;


//**********************************
function CheckInvalidSymbols(InputString:String;
                             ValidSymbols:String;
                             InvalidSymbols:String=''):Integer;
var
  StrLen:Integer;
  i:Integer;
  PosResult:Integer;
begin
  Result:=0;
  StrLen:=Length(InputString);
  //     
  for i:=1 to StrLen do
  begin
    PosResult:=Pos(InputString[i],ValidSymbols);
    if PosResult=0 then
    begin
      Result:=i;
      Break;
    end;
  end;
  if Result<>0 then Exit;
  //     
  for i:=1 to StrLen do
  begin
    PosResult:=Pos(InputString[i],InvalidSymbols);
    if PosResult<>0 then
    begin
      Result:=i;
      Break;
    end;
  end;
end;


//********************
function ReplicateChar(ResultLen:Integer;Symbol:Char):String;
var
  i:Integer;
begin
  Result:='';
  for i:=1 to ResultLen do Result:=Result+Symbol;
end;


//********************
function GetTagName(DBFName: String; TagNo: Integer): String;
const
  TEMPLATE=('0123456789.');
  MAX_LEN=8;
var
  InputStr:String;
  LeftStr:String;
  TemplateStr:String;
  FillStr:String;
  RightStr:String;
  TagNoStr:String;
  InputLen:Integer;
  LeftLen:Integer;
  TemplateLen:Integer;
  FillLen:Integer;
  RightLen:Integer;
  TagNoLen:Integer;
  i:Integer;
  TemplatePos:Integer;
  TemplateBeginPos:Integer;
begin
  if not (TagNo in [1..15]) then
  raise Exception.Create('  : '+IntToStr(TagNo)+' !'+#13+
                         ' : 1..15');
  InputStr:=UpAndTrim(Token(ExtractFileName(DBFName),'.',1));
  InputLen:=Length(InputStr);
  TemplateStr:='';
  TemplatePos:=0;
  TemplateBeginPos:=0;
  //  
  for i:=1 to InputLen do
  begin
    TemplatePos:=Pos(InputStr[i],TEMPLATE);
    if (TemplatePos<>0) and (TemplateBeginPos=0) then
      TemplateBeginPos:=i;
    if TemplateBeginPos<>0 then
      if TemplatePos<>0 then TemplateStr:=TemplateStr+InputStr[i]
      else Break;
  end;
  TemplateLen:=Length(TemplateStr);
  //  ,  
  if TemplateBeginPos=0 then LeftStr:=InputStr
  else LeftStr:=Copy(InputStr,1,TemplateBeginPos-1);
  LeftLen:=Length(LeftStr);
  //  ,  
  if TemplateBeginPos=0 then RightStr:=''
  else RightStr:=Copy(InputStr,TemplateBeginPos+TemplateLen,MAX_LEN);
  RightLen:=Length(RightStr);
  //  
  TagNoStr:=IntToHex(TagNo,1);
  TagNoLen:=Length(TagNoStr);
  //
  if LeftLen+TemplateLen+RightLen+TagNoLen>=MAX_LEN then FillStr:=''
  else FillStr:=ReplicateChar(MAX_LEN-(LeftLen+TemplateLen+RightLen+TagNoLen),'_');
  FillLen:=Length(FillStr);
  //  
  //    
  if RightLen=0 then
  begin
    //   
    if LeftLen+TemplateLen+TagNoLen>MAX_LEN then
    begin
      SetLength(LeftStr,MAX_LEN-(TemplateLen+TagNoLen));
      LeftLen:=Length(LeftStr);
    end;
    Result:=LeftStr+TemplateStr+FillStr+TagNoStr;
  end
  //    
  else begin
    //   
    if LeftLen+TemplateLen+RightLen+TagNoLen>MAX_LEN then
    begin
      SetLength(RightStr,RightLen-1);
      RightLen:=Length(RightStr);
    end;
    if LeftLen+TemplateLen+RightLen+TagNoLen>MAX_LEN then
    begin
      SetLength(LeftStr,MAX_LEN-TemplateLen+RightLen+TagNoLen);
      //LeftLen:=Length(LeftStr);
    end;
    Result:=LeftStr+TemplateStr+RightStr+FillStr+TagNoStr;
  end;
end;

//********************
function GetTemplateName(DBFName:String):String;
const
  TEMPLATE_SYMBOLS=['0'..'9'];
var
  ATableName:String;
  i:Integer;
begin
  ATableName:=UpAndTrim(Token(ExtractFileName(DBFName),'.',1));
  for i:=1 to Length(ATableName) do
    if ATableName[i] in TEMPLATE_SYMBOLS then ATableName[i]:='.';
  Result:=UpAndTrim(ATableName);
end;


//********************************
function FormatTelephone;
var
  i, j: Integer;
  strTel: String;

const
  strNum = '0123456789';

begin
  strTel:= '';
  for i:= 1 to Length(Telephon) do
  begin
    if Pos(Telephon[i], strNum) > 0 then
      strTel:= strTel + Telephon[i];
  end;
  Result:= Telephon;
  case Length(strTel) of
     1: Result:= strTel;
     2: Result:= strTel;
     3: Result:= FormatFloat('#"-"##', StrToFloat(strTel));
     4: Result:= FormatFloat('##"-"##', StrToFloat(strTel));
     5: Result:= FormatFloat('#"-"##"-"##', StrToFloat(strTel));
     6: Result:= FormatFloat('##"-"##"-"##', StrToFloat(strTel));
     7: Result:= FormatFloat('#"-"###"-"###', StrToFloat(strTel));
     8: Result:= FormatFloat('##"-"###"-"###', StrToFloat(strTel));
     9: Result:= FormatFloat('###"-"###"-"###', StrToFloat(strTel));
    10: Result:= FormatFloat('###"-"#"-"###"-"###', StrToFloat(strTel));
    11: Result:= FormatFloat('#"-"###"-"#"-"###"-"###', StrToFloat(strTel));
  end;
end;
//********************************
Function Right;
begin
  Result:= cString;
  if nCount < Length(cString) then
  begin
    Result:= Copy(cString, Length(cString) - nCount + 1, nCount);
  end;
end;
//********************
function RemoveChars(AString:String;Symbol:Char=' '):String;
var
  i:Integer;
begin
  Result:='';
  for i:=1 to Length(AString) do
  if AString[i]<>Symbol then Result:=Result+AString[i];
end;
//********************
function FilterStringInc(FilteredString:String;CharSequence:String='0123456789'):String;
var
  TempStr:String;
  i:Integer;
begin
  TempStr:='';
  for i:=1 to Length(FilteredString) do
  begin
    if Pos(FilteredString[i],CharSequence)<>0 then
      TempStr:=TempStr+FilteredString[i];
  end;
  Result:=TempStr;
end;
//********************
function DeleteSubString(AString:String;SubString:String;NoCase:Boolean=True):String;
var
  TempString:String;
  TempSubString:String;
  BeginPos:Integer;
  SubStrLen:Integer;
  LeftLen:Integer;
  RigthLen:Integer;
begin
  Result:=AString;
  SubStrLen:=0;
  BeginPos:=0;
  if NoCase then
  begin
    TempString:=AnsiUpperCase(AString);
    TempSubString:=AnsiUpperCase(SubString);
  end
  else begin
    TempString:=AString;
    TempSubString:=SubString;
  end;
  BeginPos:=Pos(TempSubString,TempString);
  if BeginPos=0 then Exit;
  SubStrLen:=Length(SubString);
  LeftLen:=BeginPos-1;
  RigthLen:=Length(AString)-LeftLen-SubStrLen;
  Result:=Copy(AString,1,LeftLen)+Copy(AString,BeginPos+SubStrLen,RigthLen);
end;

//********************
function GetIntegerSequence(SequenceString:String):TIntegerSequence;
var
  Diapason:TStringList;
  ItemsCount:Integer;
  ResultList:TStringList;
  i:Integer;
  CurrNum:String;
  MinNum:Integer;
  MaxNum:Integer;
  TempNum:Integer;
  j:Integer;
begin
  Diapason:=TStringList.Create;
  ResultList:=TStringList.Create;
  try
    ItemsCount:=NumToken(SequenceString,',');
    //   ,  
    for i:=1 to ItemsCount do
    begin
      CurrNum:=Token(SequenceString,',',i);
      //  
      if Pos('-',CurrNum)<>0
      then Diapason.Add(RemoveChars(CurrNum,' '))
      //  
      else begin
        try
          ResultList.Add(CurrNum);
        except
        end;
      end;
    end;
    //      
    ItemsCount:=Diapason.Count;
    if ItemsCount=0 then ItemsCount:=1;
    for i:=0 to ItemsCount-1 do
    begin
      try
        MinNum:=StrToInt(Token(Diapason[i],'-',1));
        MaxNum:=StrToInt(Token(Diapason[i],'-',2));
        if MinNum>MaxNum then
        begin
          TempNum:=MinNum;
          MinNum:=MaxNum;
          MaxNuM:=TempNum;
        end;
        for j:=MinNum to MaxNum do ResultList.Add(IntToStr(j));
      except
      end;
    end;
    //   
    ItemsCount:=ResultList.Count;
    SetLength(Result,ItemsCount);
    for i:=0 to ItemsCount-1 do Result[i]:=StrToInt(ResultList[i]);
    SortIntegerSequence(Result);
  finally
    Diapason.Free;
    Diapason:=nil;
    ResultList.Free;
    ResultList:=nil;
  end;
end;
//********************

function ReplaceChar(S: String; NewChar, OldChar: PChar): String;
var
  nPos: Integer;
  S1, S2: String;
  
begin
  Result:= S;
  nPos:= Pos(OldChar, S);
  if nPos = 0 then exit;
  S1:= copy(S, 1, nPos-1);
  S2:= copy(S, nPos+1, length(S)-nPos);
  Result:= S1 + NewChar + S2;
end;
//********************
function ReverceString(InputString:String):String;
var
  StrLen:Integer;
  i:Integer;
begin
  Result:='';
  StrLen:=Length(InputString);
  for i:= StrLen downto 1 do
  begin
    Result:=Result+InputString[i];
  end;
end;
//********************
end.
