unit ifpii_SysImp;
{
Compile Time Importing Unit for SysUtils for ifps3

Release 0.01 beta
Date : 11th July 2002

License
This code is Copyright (c) 2002 Tejasvi Hegde

This software is provided 'as-is', without any express or implied warranty.
In no event will the authors be held liable for any damages arising from the
use of this software.

Permission is granted to anyone to use this software for any purpose, including
commercial applications, and to alter it and redistribute it freely, subject to
the following restrictions:

1. The origin of this software must not be misrepresented; you must not claim
that you wrote the original software. If you use this software in a product,
an acknowledgment in the product documentation would be appreciated but is not
required.

2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.

3. This notice may not be removed or altered from any source distribution.

4. USE AT YOUR OWN RISK

Credits:
Innerfuse Pascal script is a copyright of innerfuse it is available at
http://www.carlo-kok.com

Notes:
See Readme.txt
}


{$I ifps3_def.inc}
interface
uses
  ifpscomp, ifps3common, ifps3utl, ifpiclass;
  procedure Register_SysUtilsImp_C(PC: TIFPSPascalCompiler);
implementation
uses
  SysUtils,ifpidelphi;

procedure Register_SysUtilsImp_C(PC: TIFPSPascalCompiler);
begin

  PC.AddTypeS('TReplaceFlags', 'set of (rfReplaceAll, rfIgnoreCase)');
  PC.AddTypeS('TFilenameCaseMatch', '(mkNone, mkExactMatch, mkSingleMatch, mkAmbiguous)');
  PC.AddTypeS('TTextLineBreakStyle', '(tlbsLF, tlbsCRLF)');

  PC.AddTypeS('TDateTime','Double');
  RegisterDelphiFunctionC(PC,'function UpperCase(S: string): string;');
  RegisterDelphiFunctionC(PC,'function LowerCase(S: string): string;');
  RegisterDelphiFunctionC(PC,'function CompareStr(S1, S2: string): Integer;');

  RegisterDelphiFunctionC(PC,'function CompareText( S1, S2: string): Integer;');
  RegisterDelphiFunctionC(PC,'function SameText( S1, S2: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function AnsiUpperCase( S: string): string;');
  RegisterDelphiFunctionC(PC,'function AnsiLowerCase( S: string): string;');
  RegisterDelphiFunctionC(PC,'function AnsiCompareStr( S1, S2: string): Integer;');
  RegisterDelphiFunctionC(PC,'function AnsiSameStr( S1, S2: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function AnsiCompareText( S1, S2: string): Integer;');
  RegisterDelphiFunctionC(PC,'function AnsiSameText( S1, S2: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function AnsiStrComp(S1, S2: PChar): Integer;');
  RegisterDelphiFunctionC(PC,'function AnsiStrIComp(S1, S2: PChar): Integer;');
  RegisterDelphiFunctionC(PC,'function AnsiStrLComp(S1, S2: PChar; MaxLen: Cardinal): Integer;');
  RegisterDelphiFunctionC(PC,'function AnsiStrLIComp(S1, S2: PChar; MaxLen: Cardinal): Integer;');
  RegisterDelphiFunctionC(PC,'function AnsiStrLower(Str: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function AnsiStrUpper(Str: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function AnsiLastChar( S: string): PChar;');
  RegisterDelphiFunctionC(PC,'function AnsiStrLastChar(P: PChar): PChar;');

  RegisterDelphiFunctionC(PC,'function Trim( S: string): string;');

  RegisterDelphiFunctionC(PC,'function TrimLeft( S: string): string;');

  RegisterDelphiFunctionC(PC,'function TrimRight( S: string): string;');

  RegisterDelphiFunctionC(PC,'function QuotedStr( S: string): string;');
  RegisterDelphiFunctionC(PC,'function AnsiQuotedStr( S: string; Quote: Char): string;');
  RegisterDelphiFunctionC(PC,'function AnsiExtractQuotedStr(var Src: PChar; Quote: Char): string;');
  RegisterDelphiFunctionC(PC,'function AnsiDequotedStr( S: string; AQuote: Char): string;');
  RegisterDelphiFunctionC(PC,'function AdjustLineBreaks( S: string; Style: TTextLineBreakStyle);');
  RegisterDelphiFunctionC(PC,'function IsValidIdent( Ident: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function IntToStr(Value: Integer): string;');
  RegisterDelphiFunctionC(PC,'function Int64ToStr(Value: Int64): string;');
  RegisterDelphiFunctionC(PC,'function IntToHex(Value: Integer; Digits: Integer): string;');
  RegisterDelphiFunctionC(PC,'function Int64ToHex(Value: Int64; Digits: Integer): string;');
  RegisterDelphiFunctionC(PC,'function StrToInt( S: string): Integer;');
  RegisterDelphiFunctionC(PC,'function StrToIntDef( S: string; Default: Integer): Integer;');
  RegisterDelphiFunctionC(PC,'function TryStrToInt( S: string; Value: Integer): Boolean;');
  RegisterDelphiFunctionC(PC,'function StrToInt64( S: string): Int64;');
  RegisterDelphiFunctionC(PC,'function StrToInt64Def( S: string;  Default: Int64): Int64;');
  RegisterDelphiFunctionC(PC,'function TryStrToInt64( S: string; Value: Int64): Boolean;');
  RegisterDelphiFunctionC(PC,'function StrToBool( S: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function StrToBoolDef( S: string;  Default: Boolean): Boolean;');
  RegisterDelphiFunctionC(PC,'function TryStrToBool( S: string; Value: Boolean): Boolean;');
  RegisterDelphiFunctionC(PC,'function BoolToStr(B: Boolean; UseBoolStrs: Boolean): string;');
  RegisterDelphiFunctionC(PC,'function LoadStr(Ident: Integer): string;');
  RegisterDelphiFunctionC(PC,'function FmtLoadStr(Ident: Integer;  Args: array of const): string;');

{ File management routines }
  RegisterDelphiFunctionC(PC,'function FileOpen( FileName: string; Mode: LongWord): Integer;');
  RegisterDelphiFunctionC(PC,'function FileCreate( FileName: string): Integer;');
  RegisterDelphiFunctionC(PC,'function FileCreateRights( FileName: string; Rights: Integer): Integer;');
  RegisterDelphiFunctionC(PC,'function FileRead(Handle: Integer; var Buffer; Count: LongWord): Integer;');
  RegisterDelphiFunctionC(PC,'function FileWrite(Handle: Integer;  Buffer; Count: LongWord): Integer;');
  RegisterDelphiFunctionC(PC,'function FileSeek(Handle, Offset, Origin: Integer): Integer;');
  RegisterDelphiFunctionC(PC,'function FileSeek64(Handle: Integer;  Offset: Int64; Origin: Integer): Int64;');
  RegisterDelphiFunctionC(PC,'procedure FileClose(Handle: Integer);');


  RegisterDelphiFunctionC(PC,'function FileAge( FileName: string): Integer;');
  RegisterDelphiFunctionC(PC,'function FileExists( FileName: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function DirectoryExists( Directory: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function ForceDirectories(Dir: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function FileGetDate(Handle: Integer): Integer;');
  RegisterDelphiFunctionC(PC,'function FileSetDate( FileName: string; Age: Integer): Integer;');
  RegisterDelphiFunctionC(PC,'function FileIsReadOnly( FileName: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function FileSetReadOnly( FileName: string; ReadOnly: Boolean): Boolean;');
  RegisterDelphiFunctionC(PC,'function DeleteFile( FileName: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function RenameFile( OldName, NewName: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function ChangeFileExt( FileName, Extension: string): string;');
  RegisterDelphiFunctionC(PC,'function ExtractFilePath( FileName: string): string;');
  RegisterDelphiFunctionC(PC,'function ExtractFileDir( FileName: string): string;');
  RegisterDelphiFunctionC(PC,'function ExtractFileDrive( FileName: string): string;');
  RegisterDelphiFunctionC(PC,'function ExtractFileName( FileName: string): string;');
  RegisterDelphiFunctionC(PC,'function ExtractFileExt( FileName: string): string;');
  RegisterDelphiFunctionC(PC,'function ExpandFileName( FileName: string): string;');

  RegisterDelphiFunctionC(PC,'function ExpandFileNameCase( FileName: string; MatchFound: TFilenameCaseMatch): string;');
  RegisterDelphiFunctionC(PC,'function ExpandUNCFileName( FileName: string): string;');
  RegisterDelphiFunctionC(PC,'function ExtractRelativePath( BaseName, DestName: string): string;');
  RegisterDelphiFunctionC(PC,'function FileSearch( Name, DirList: string): string;');
  RegisterDelphiFunctionC(PC,'function FileDateToDateTime(FileDate: Integer): TDateTime;');
  RegisterDelphiFunctionC(PC,'function DateTimeToFileDate(DateTime: TDateTime): Integer;');
  RegisterDelphiFunctionC(PC,'function GetCurrentDir: string;');
  RegisterDelphiFunctionC(PC,'function SetCurrentDir( Dir: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function CreateDir( Dir: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function RemoveDir( Dir: string): Boolean;');

{ PChar routines }
  RegisterDelphiFunctionC(PC,'function StrLen( Str: PChar): Cardinal;');
  RegisterDelphiFunctionC(PC,'function StrEnd( Str: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function StrMove(Dest: PChar;  Source: PChar; Count: Cardinal): PChar;');
  RegisterDelphiFunctionC(PC,'function StrCopy(Dest: PChar;  Source: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function StrECopy(Dest:PChar;  Source: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function StrLCopy(Dest: PChar;  Source: PChar; MaxLen: Cardinal): PChar;');
  RegisterDelphiFunctionC(PC,'function StrPCopy(Dest: PChar;  Source: string): PChar;');
  RegisterDelphiFunctionC(PC,'function StrPLCopy(Dest: PChar;  Source: string; MaxLen: Cardinal): PChar;');
  RegisterDelphiFunctionC(PC,'function StrCat(Dest: PChar;  Source: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function StrLCat(Dest: PChar;  Source: PChar; MaxLen: Cardinal): PChar;');
  RegisterDelphiFunctionC(PC,'function StrComp( Str1, Str2: PChar): Integer;');
  RegisterDelphiFunctionC(PC,'function StrIComp( Str1, Str2: PChar): Integer;');
  RegisterDelphiFunctionC(PC,'function StrLComp( Str1, Str2: PChar; MaxLen: Cardinal): Integer;');
  RegisterDelphiFunctionC(PC,'function StrLIComp( Str1, Str2: PChar; MaxLen: Cardinal): Integer;');
  RegisterDelphiFunctionC(PC,'function StrScan( Str: PChar; Chr: Char): PChar;');
  RegisterDelphiFunctionC(PC,'function StrRScan( Str: PChar; Chr: Char): PChar;');
  RegisterDelphiFunctionC(PC,'function StrPos( Str1, Str2: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function StrUpper(Str: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function StrLower(Str: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function StrPas( Str: PChar): string;');
  RegisterDelphiFunctionC(PC,'function StrAlloc(Size: Cardinal): PChar;');
  RegisterDelphiFunctionC(PC,'function StrBufSize( Str: PChar): Cardinal;');
  RegisterDelphiFunctionC(PC,'function StrNew( Str: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'procedure StrDispose(Str: PChar);');

  RegisterDelphiFunctionC(PC,'function Format( Format: string;  Args: array of const): string;');
  RegisterDelphiFunctionC(PC,'procedure FmtStr(var Result: string;  Format: string;  Args: array of const);');
  RegisterDelphiFunctionC(PC,'function StrFmt(Buffer, Format: PChar;  Args: array of const): PChar;');
  RegisterDelphiFunctionC(PC,'function StrLFmt(Buffer: PChar; MaxBufLen: Cardinal; Format: PChar;  Args: array of const): PChar;');
  RegisterDelphiFunctionC(PC,'function FormatBuf(var Buffer; BufLen: Cardinal;  Format;  FmtLen: Cardinal;  Args: array of const): Cardinal;');

{ Floating point conversion routines }

  RegisterDelphiFunctionC(PC,'function FloatToStr(Value: Extended): string;');
  RegisterDelphiFunctionC(PC,'function CurrToStr(Value: Currency): string;');

  RegisterDelphiFunctionC(PC,'function FloatToCurr( Value: Extended): Currency;');
  RegisterDelphiFunctionC(PC,'function FloatToStrF(Value: Extended; Format: TFloatFormat;  Precision, Digits: Integer): string;');
  RegisterDelphiFunctionC(PC,'function CurrToStrF(Value: Currency; Format: TFloatFormat;  Digits: Integer): string;');
  RegisterDelphiFunctionC(PC,'function FloatToText(BufferArg: PChar;  Value; ValueType: TFloatValue;  Format: TFloatFormat; Precision, Digits: Integer): Integer;');
  RegisterDelphiFunctionC(PC,'function FormatFloat( Format: string; Value: Extended): string;');
  RegisterDelphiFunctionC(PC,'function FormatCurr( Format: string; Value: Currency): string;');
  RegisterDelphiFunctionC(PC,'function FloatToTextFmt(Buf: PChar;  Value; ValueType: TFloatValue;  Format: PChar): Integer;');
  RegisterDelphiFunctionC(PC,'function StrToFloat( S: string): Extended;');
  RegisterDelphiFunctionC(PC,'function StrToFloatDef( S: string;  Default: Extended): Extended;');
  RegisterDelphiFunctionC(PC,'function TryStrToFloatEx( S: string; Value: Extended): Boolean;');
  RegisterDelphiFunctionC(PC,'function TryStrToFloatDbl( S: string; Value: Double): Boolean;');
  RegisterDelphiFunctionC(PC,'function TryStrToFloatSngl( S: string; Value: Single): Boolean;');
  RegisterDelphiFunctionC(PC,'function StrToCurr( S: string): Currency;');
  RegisterDelphiFunctionC(PC,'function StrToCurrDef( S: string;  Default: Currency): Currency;');
  RegisterDelphiFunctionC(PC,'function TryStrToCurr( S: string; Value: Currency): Boolean;');
  RegisterDelphiFunctionC(PC,'function TextToFloat(Buffer: PChar; var Value;  ValueType: TFloatValue): Boolean;');
  RegisterDelphiFunctionC(PC,'procedure FloatToDecimal(var Result: TFloatRec;  Value;  ValueType: TFloatValue; Precision, Decimals: Integer);');

{ Date/time support routines }
  RegisterDelphiFunctionC(PC,'function DateTimeToTimeStamp(DateTime: TDateTime): TTimeStamp;');
  RegisterDelphiFunctionC(PC,'function TimeStampToDateTime( TimeStamp: TTimeStamp): TDateTime;');
  RegisterDelphiFunctionC(PC,'function MSecsToTimeStamp(MSecs: Comp): TTimeStamp;');
  RegisterDelphiFunctionC(PC,'function TimeStampToMSecs( TimeStamp: TTimeStamp): Comp;');

  RegisterDelphiFunctionC(PC,'function EncodeDate(Year, Month, Day: Word): TDateTime;');
  RegisterDelphiFunctionC(PC,'function EncodeTime(Hour, Min, Sec, MSec: Word): TDateTime;');
  RegisterDelphiFunctionC(PC,'function TryEncodeDate(Year, Month, Day: Word; Date: TDateTime): Boolean;');
  RegisterDelphiFunctionC(PC,'function TryEncodeTime(Hour, Min, Sec, MSec: Word; Time: TDateTime): Boolean;');

  RegisterDelphiFunctionC(PC,'procedure DecodeDate( DateTime: TDateTime; var Year, Month, Day: Word);');
  RegisterDelphiFunctionC(PC,'function DecodeDateFully( DateTime: TDateTime; var Year, Month, Day, DOW: Word): Boolean;');

  RegisterDelphiFunctionC(PC,'procedure DecodeTime( DateTime: TDateTime; var Hour, Min, Sec, MSec: Word);');
  RegisterDelphiFunctionC(PC,'function DayOfWeek( DateTime: TDateTime): Word;');
  RegisterDelphiFunctionC(PC,'function Date: TDateTime;');
  RegisterDelphiFunctionC(PC,'function Time: TDateTime;');
  RegisterDelphiFunctionC(PC,'function Now: TDateTime;');
  RegisterDelphiFunctionC(PC,'function CurrentYear: Word;');
  RegisterDelphiFunctionC(PC,'function IncMonth( DateTime: TDateTime; NumberOfMonths: Integer): TDateTime;');
  RegisterDelphiFunctionC(PC,'procedure IncAMonth(var Year, Month, Day: Word; NumberOfMonths: Integer);');
  RegisterDelphiFunctionC(PC,'procedure ReplaceTime(var DateTime: TDateTime;  NewTime: TDateTime);');
  RegisterDelphiFunctionC(PC,'procedure ReplaceDate(var DateTime: TDateTime;  NewDate: TDateTime);');
  RegisterDelphiFunctionC(PC,'function IsLeapYear(Year: Word): Boolean;');


  RegisterDelphiFunctionC(PC,'function DateToStr( DateTime: TDateTime): string;');
  RegisterDelphiFunctionC(PC,'function TimeToStr( DateTime: TDateTime): string;');
  RegisterDelphiFunctionC(PC,'function DateTimeToStr( DateTime: TDateTime): string;');
  RegisterDelphiFunctionC(PC,'function StrToDate( S: string): TDateTime;');
  RegisterDelphiFunctionC(PC,'function StrToDateDef( S: string;  Default: TDateTime): TDateTime;');
  RegisterDelphiFunctionC(PC,'function TryStrToDate( S: string; Value: TDateTime): Boolean;');
  RegisterDelphiFunctionC(PC,'function StrToTime( S: string): TDateTime;');
  RegisterDelphiFunctionC(PC,'function StrToTimeDef( S: string;  Default: TDateTime): TDateTime;');
  RegisterDelphiFunctionC(PC,'function TryStrToTime( S: string; Value: TDateTime): Boolean;');
  RegisterDelphiFunctionC(PC,'function StrToDateTime( S: string): TDateTime;');
  RegisterDelphiFunctionC(PC,'function StrToDateTimeDef( S: string;  Default: TDateTime): TDateTime;');
  RegisterDelphiFunctionC(PC,'function TryStrToDateTime( S: string; Value: TDateTime): Boolean;');

  RegisterDelphiFunctionC(PC,'function FormatDateTime( Format: string; DateTime: TDateTime): string;');
  RegisterDelphiFunctionC(PC,'procedure DateTimeToString(var Result: string;  Format: string; DateTime: TDateTime);');

  RegisterDelphiFunctionC(PC,'function FloatToDateTime( Value: Extended): TDateTime;');
  RegisterDelphiFunctionC(PC,'function SysErrorMessage(ErrorCode: Integer): string;');

  RegisterDelphiFunctionC(PC,'procedure GetFormatSettings;');

{ In Linux, the parameter to sleep() is in whole seconds.  In Windows, the
  parameter is in milliseconds.  To ease headaches, we implement a version
  of sleep here for Linux that takes milliseconds and calls a Linux system
    RegisterDelphiFunctionC(PC,'function with sub-second resolution.  This maps directly to the Windows
  API on Windows. }

 // RegisterDelphiFunctionC(PC,'procedure Sleep(milliseconds: Cardinal);{$IFDEF MSWINDOWS} stdcall; {$ENDIF}');
  RegisterDelphiFunctionC(PC,'procedure Sleep(milliseconds: Cardinal);');
  RegisterDelphiFunctionC(PC,'procedure Beep;');

  RegisterDelphiFunctionC(PC,'function IsPathDelimiter( S: string; Index: Integer): Boolean;');
  RegisterDelphiFunctionC(PC,'function IsDelimiter( Delimiters, S: string; Index: Integer): Boolean;');
  RegisterDelphiFunctionC(PC,'function IncludeTrailingPathDelimiter( S: string): string;');
  RegisterDelphiFunctionC(PC,'function ExcludeTrailingPathDelimiter( S: string): string;');
  RegisterDelphiFunctionC(PC,'function LastDelimiter( Delimiters, S: string): Integer;');
  RegisterDelphiFunctionC(PC,'function AnsiCompareFileName( S1, S2: string): Integer;');
  RegisterDelphiFunctionC(PC,'function SameFileName( S1, S2: string): Boolean;');
  RegisterDelphiFunctionC(PC,'function AnsiLowerCaseFileName( S: string): string;');
  RegisterDelphiFunctionC(PC,'function AnsiUpperCaseFileName( S: string): string;');
  RegisterDelphiFunctionC(PC,'function AnsiPos( Substr, S: string): Integer;');
  RegisterDelphiFunctionC(PC,'function AnsiStrPos(Str, SubStr: PChar): PChar;');
  RegisterDelphiFunctionC(PC,'function AnsiStrRScan(Str: PChar; Chr: Char): PChar;');
  RegisterDelphiFunctionC(PC,'function AnsiStrScan(Str: PChar; Chr: Char): PChar;');

  RegisterDelphiFunctionC(PC,'function StringReplace( S, OldPattern, NewPattern: string; Flags: TReplaceFlags): string;');
  RegisterDelphiFunctionC(PC,'function WrapTextChr( Line, BreakStr: string;  BreakChars: TSysCharSet;  MaxCol: Integer): string;');
  RegisterDelphiFunctionC(PC,'function WrapText( Line: string; MaxCol: Integer): string;');
end;


end.
