unit ifpiir_SysImp;
{
Run Time Importing Unit for SysUtils for ifps3

Release 0.01 beta
Date : 11th July 2002

License
This code is Copyright (c) 2002 Tejasvi Hegde

This software is provided 'as-is', without any express or implied warranty.
In no event will the authors be held liable for any damages arising from the
use of this software.

Permission is granted to anyone to use this software for any purpose, including
commercial applications, and to alter it and redistribute it freely, subject to
the following restrictions:

1. The origin of this software must not be misrepresented; you must not claim
that you wrote the original software. If you use this software in a product,
an acknowledgment in the product documentation would be appreciated but is not
required.

2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.

3. This notice may not be removed or altered from any source distribution.

4. USE AT YOUR OWN RISK

Credits:
Innerfuse Pascal script is a copyright of innerfuse it is available at
http://www.carlo-kok.com

Notes:
See Readme.txt
}

{$I ifps3_def.inc}
interface
uses
  ifps3, ifps3common, ifps3utl, ifpiclassruntime, FileCtrl,
  SysUtils, ifpidelphiruntime;

  procedure Register_SysUtilsImp_R(PE: TIFPSExec);

implementation


function Int64ToStr(Value: Int64): string;
begin
        Result := IntToStr(Value);
end;
function Int64ToHex(Value: Int64; Digits: Integer): string;
begin
         Result := IntToHex(Value,Digits);
end;
function StrToInt64( S: string): Int64;
begin
       Result := StrToInt(S);
end;
function StrToInt64Def( S: string;  Default: Int64): Int64;
begin
      Result := StrToIntDef(S,Default);
end;
function FileCreateRights( FileName: string; Rights: Integer): Integer;
begin
         Result := FileCreate(FileName);
end;
function FileSeek64(Handle: Integer;  Offset: Int64; Origin: Integer): Int64;
begin
         Result := FileSeek64(Handle,Offset,Origin);
end;
{
function TryStrToFloatEx( S: string; Value: Extended): Boolean;
begin
         Result := TryStrToFloat(S,Value);
end;
function TryStrToFloatDbl( S: string; Value: Double): Boolean;
begin
         Result := TryStrToFloat(S,Value);
end;
function TryStrToFloatSngl( S: string; Value: Single): Boolean;
begin
         Result := TryStrToFloat(S,Value);
end;
}
function WrapTextChr( Line, BreakStr: string;  BreakChars: TSysCharSet;  MaxCol: Integer): string;
begin
        Result := WrapText( Line, BreakStr,BreakChars,MaxCol);
end;

procedure Register_SysUtilsImp_R(PE: TIFPSExec);
  procedure AddFunctionR(ProcPtr: pointer; const Name: string;CC:TDelphiCallingConvention=cdRegister);
  begin
    if Assigned(PE) Then Begin
      RegisterDelphiFunctionR(PE,ProcPtr,UpperCase(Name),CC);
    End;
  end;
begin


  AddFunctionR(@UpperCase,'UpperCase');
  AddFunctionR(@LowerCase,'LowerCase');
  AddFunctionR(@CompareStr,'CompareStr');

  AddFunctionR(@CompareText,'CompareText');
  AddFunctionR(@SameText,'SameText');
  AddFunctionR(@AnsiUpperCase,'AnsiUpperCase');
  AddFunctionR(@AnsiLowerCase,'AnsiLowerCase');
  AddFunctionR(@AnsiCompareStr,'AnsiCompareStr');
  AddFunctionR(@AnsiSameStr,'AnsiSameStr');
  AddFunctionR(@AnsiCompareText,'AnsiCompareText');
  AddFunctionR(@AnsiSameText,'AnsiSameText');
  AddFunctionR(@AnsiStrComp,'AnsiStrComp');
  AddFunctionR(@AnsiStrIComp,'AnsiStrIComp');
  AddFunctionR(@AnsiStrLComp,'AnsiStrLComp');
  AddFunctionR(@AnsiStrLIComp,'AnsiStrLIComp');
  AddFunctionR(@AnsiStrLower,'AnsiStrLower');
  AddFunctionR(@AnsiStrUpper,'AnsiStrUpper');
  AddFunctionR(@AnsiLastChar,'AnsiLastChar');
  AddFunctionR(@AnsiStrLastChar,'AnsiStrLastChar');

  AddFunctionR(@Trim,'Trim');

  AddFunctionR(@TrimLeft,'TrimLeft');

  AddFunctionR(@TrimRight,'TrimRight');

  AddFunctionR(@QuotedStr,'QuotedStr');
  AddFunctionR(@AnsiQuotedStr,'AnsiQuotedStr');
  AddFunctionR(@AnsiExtractQuotedStr,'AnsiExtractQuotedStr');
  //AddFunctionR(@AnsiDequotedStr,'AnsiDequotedStr');
  AddFunctionR(@AdjustLineBreaks,'AdjustLineBreaks');
  AddFunctionR(@IsValidIdent,'IsValidIdent');
  AddFunctionR(@IntToStr,'IntToStr');
  AddFunctionR(@Int64ToStr,'Int64ToStr');
  AddFunctionR(@IntToHex,'IntToHex');
  AddFunctionR(@Int64ToHex,'Int64ToHex');
  AddFunctionR(@StrToInt,'StrToInt');
  AddFunctionR(@StrToIntDef,'StrToIntDef');
  //AddFunctionR(@TryStrToInt,'TryStrToInt');
  AddFunctionR(@StrToInt64,'StrToInt64');
  AddFunctionR(@StrToInt64Def,'StrToInt64Def');
  //AddFunctionR(@TryStrToInt64,'TryStrToInt64');
  //AddFunctionR(@StrToBool,'StrToBool');
  //AddFunctionR(@StrToBoolDef,'StrToBoolDef');
  //AddFunctionR(@TryStrToBool,'TryStrToBool');
  //AddFunctionR(@BoolToStr,'BoolToStr');
  AddFunctionR(@LoadStr,'LoadStr');
  AddFunctionR(@FmtLoadStr,'FmtLoadStr');

{ File management routines }
  AddFunctionR(@FileOpen,'FileOpen');
  AddFunctionR(@FileCreate,'FileCreate');
  AddFunctionR(@FileCreateRights,'FileCreateRights');
  AddFunctionR(@FileRead,'FileRead');
  AddFunctionR(@FileWrite,'FileWrite');
  AddFunctionR(@FileSeek,'FileSeek');
  AddFunctionR(@FileSeek64,'FileSeek64');
  AddFunctionR(@FileClose,'FileClose');


  AddFunctionR(@FileAge,'FileAge');
  AddFunctionR(@FileExists,'FileExists');
  AddFunctionR(@DirectoryExists,'DirectoryExists');
  AddFunctionR(@ForceDirectories,'ForceDirectories');
  AddFunctionR(@FileGetDate,'FileGetDate');
  AddFunctionR(@FileSetDate,'FileSetDate');
  //AddFunctionR(@FileIsReadOnly,'FileIsReadOnly');
  //AddFunctionR(@FileSetReadOnly,'FileSetReadOnly');
  AddFunctionR(@DeleteFile,'DeleteFile');
  AddFunctionR(@RenameFile,'RenameFile');
  AddFunctionR(@ChangeFileExt,'ChangeFileExt');
  AddFunctionR(@ExtractFilePath,'ExtractFilePath');
  AddFunctionR(@ExtractFileDir,'ExtractFileDir');
  AddFunctionR(@ExtractFileDrive,'ExtractFileDrive');
  AddFunctionR(@ExtractFileName,'ExtractFileName');
  AddFunctionR(@ExtractFileExt,'ExtractFileExt');
  AddFunctionR(@ExpandFileName,'ExpandFileName');

  //AddFunctionR(@ExpandFileNameCase,'ExpandFileNameCase');
  AddFunctionR(@ExpandUNCFileName,'ExpandUNCFileName');
  AddFunctionR(@ExtractRelativePath,'ExtractRelativePath');
  AddFunctionR(@FileSearch,'FileSearch');
  AddFunctionR(@FileDateToDateTime,'FileDateToDateTime');
  AddFunctionR(@DateTimeToFileDate,'DateTimeToFileDate');
  AddFunctionR(@GetCurrentDir,'GetCurrentDir');
  AddFunctionR(@SetCurrentDir,'SetCurrentDir');
  AddFunctionR(@CreateDir,'CreateDir');
  AddFunctionR(@RemoveDir,'RemoveDir');

{ PChar routines }
  AddFunctionR(@StrLen,'StrLen');
  AddFunctionR(@StrEnd,'StrEnd');
  AddFunctionR(@StrMove,'StrMove');
  AddFunctionR(@StrCopy,'StrCopy');
  AddFunctionR(@StrECopy,'StrECopy');
  AddFunctionR(@StrLCopy,'StrLCopy');
  AddFunctionR(@StrPCopy,'StrPCopy');
  AddFunctionR(@StrPLCopy,'StrPLCopy');
  AddFunctionR(@StrCat,'StrCat');
  AddFunctionR(@StrLCat,'StrLCat');
  AddFunctionR(@StrComp,'StrComp');
  AddFunctionR(@StrIComp,'StrIComp');
  AddFunctionR(@StrLComp,'StrLComp');
  AddFunctionR(@StrLIComp,'StrLIComp');
  AddFunctionR(@StrScan,'StrScan');
  AddFunctionR(@StrRScan,'StrRScan');
  AddFunctionR(@StrPos,'StrPos');
  AddFunctionR(@StrUpper,'StrUpper');
  AddFunctionR(@StrLower,'StrLower');
  AddFunctionR(@StrPas,'StrPas');
  AddFunctionR(@StrAlloc,'StrAlloc');
  AddFunctionR(@StrBufSize,'StrBufSize');
  AddFunctionR(@StrNew,'StrNew');
  AddFunctionR(@StrDispose,'StrDispose');

  AddFunctionR(@Format,'Format');
  AddFunctionR(@FmtStr,'FmtStr');
  AddFunctionR(@StrFmt,'StrFmt');
  AddFunctionR(@StrLFmt,'StrLFmt');
  AddFunctionR(@FormatBuf,'FormatBuf');

{ Floating point conversion routines }

  AddFunctionR(@FloatToStr,'FloatToStr');
  AddFunctionR(@CurrToStr,'CurrToStr');

  //AddFunctionR(@FloatToCurr,'FloatToCurr');
  AddFunctionR(@FloatToStrF,'FloatToStrF');
  AddFunctionR(@CurrToStrF,'CurrToStrF');
  AddFunctionR(@FloatToText,'FloatToText');
  AddFunctionR(@FormatFloat,'FormatFloat');
  AddFunctionR(@FormatCurr,'FormatCurr');
  AddFunctionR(@FloatToTextFmt,'FloatToTextFmt');
  AddFunctionR(@StrToFloat,'StrToFloat');
  //AddFunctionR(@StrToFloatDef,'StrToFloatDef');
  //AddFunctionR(@TryStrToFloatEx,'TryStrToFloatEx');
  //AddFunctionR(@TryStrToFloatDbl,'TryStrToFloatDbl');
  //AddFunctionR(@TryStrToFloatSngl,'TryStrToFloatSngl');
  AddFunctionR(@StrToCurr,'StrToCurr');
  //AddFunctionR(@StrToCurrDef,'StrToCurrDef');
  //AddFunctionR(@TryStrToCurr,'TryStrToCurr');
  AddFunctionR(@TextToFloat,'TextToFloat');
  AddFunctionR(@FloatToDecimal,'FloatToDecimal');

{ Date/time support routines }
  AddFunctionR(@DateTimeToTimeStamp,'DateTimeToTimeStamp');
  AddFunctionR(@TimeStampToDateTime,'TimeStampToDateTime');
  AddFunctionR(@MSecsToTimeStamp,'MSecsToTimeStamp');
  AddFunctionR(@TimeStampToMSecs,'TimeStampToMSecs');

  AddFunctionR(@EncodeDate,'EncodeDate');
  AddFunctionR(@EncodeTime,'EncodeTime');
  //AddFunctionR(@TryEncodeDate,'TryEncodeDate');
  //AddFunctionR(@TryEncodeTime,'TryEncodeTime');

  AddFunctionR(@DecodeDate,'DecodeDate');
  //AddFunctionR(@DecodeDateFully,'DecodeDateFully');

  AddFunctionR(@DecodeTime,'DecodeTime');
  AddFunctionR(@DayOfWeek,'DayOfWeek');
  AddFunctionR(@Date,'Date');
  AddFunctionR(@Time,'Time');
  AddFunctionR(@Now,'Now');
  //AddFunctionR(@CurrentYear,'CurrentYear');
  AddFunctionR(@IncMonth,'IncMonth');
  //AddFunctionR(@IncAMonth,'IncAMonth');
  AddFunctionR(@ReplaceTime,'ReplaceTime');
  AddFunctionR(@ReplaceDate,'ReplaceDate');
  AddFunctionR(@IsLeapYear,'IsLeapYear');


  AddFunctionR(@DateToStr,'DateToStr');
  AddFunctionR(@TimeToStr,'TimeToStr');
  AddFunctionR(@DateTimeToStr,'DateTimeToStr');
  AddFunctionR(@StrToDate,'StrToDate');
  //AddFunctionR(@StrToDateDef,'StrToDateDef');
  //AddFunctionR(@TryStrToDate,'TryStrToDate');
  AddFunctionR(@StrToTime,'StrToTime');
  //AddFunctionR(@StrToTimeDef,'StrToTimeDef');
  //AddFunctionR(@TryStrToTime,'TryStrToTime');
  AddFunctionR(@StrToDateTime,'StrToDateTime');
  //AddFunctionR(@StrToDateTimeDef,'StrToDateTimeDef');
  //AddFunctionR(@TryStrToDateTime,'TryStrToDateTime');

  AddFunctionR(@FormatDateTime,'FormatDateTime');
  AddFunctionR(@DateTimeToString,'DateTimeToString');

  //AddFunctionR(@FloatToDateTime,'FloatToDateTime');
  AddFunctionR(@SysErrorMessage,'SysErrorMessage');

  AddFunctionR(@GetFormatSettings,'GetFormatSettings');

{ In Linux, the parameter to sleep() is in whole seconds.  In Windows, the
  parameter is in milliseconds.  To ease headaches, we implement a version
  of sleep here for Linux that takes milliseconds and calls a Linux system
    AddFunctionR(@with sub-second resolution.  This maps directly to the Windows
  API on Windows. }

  //AddFunctionR(@Sleep,'Sleep'{$IFDEF MSWINDOWS},CdStdCall{$ENDIF});
  AddFunctionR(@Beep,'Beep');

  AddFunctionR(@IsPathDelimiter,'IsPathDelimiter');
  AddFunctionR(@IsDelimiter,'IsDelimiter');
  //AddFunctionR(@IncludeTrailingPathDelimiter,'IncludeTrailingPathDelimiter');
  //AddFunctionR(@ExcludeTrailingPathDelimiter,'ExcludeTrailingPathDelimiter');
  AddFunctionR(@LastDelimiter,'LastDelimiter');
  AddFunctionR(@AnsiCompareFileName,'AnsiCompareFileName');
  //AddFunctionR(@SameFileName,'SameFileName');
  AddFunctionR(@AnsiLowerCaseFileName,'AnsiLowerCaseFileName');
  AddFunctionR(@AnsiUpperCaseFileName,'AnsiUpperCaseFileName');
  AddFunctionR(@AnsiPos,'AnsiPos');
  AddFunctionR(@AnsiStrPos,'AnsiStrPos');
  AddFunctionR(@AnsiStrRScan,'AnsiStrRScan');
  AddFunctionR(@AnsiStrScan,'AnsiStrScan');

  AddFunctionR(@StringReplace,'StringReplace');
  AddFunctionR(@WrapTextChr,'WrapTextChr');
  AddFunctionR(@WrapText,'WrapText');

end;
end.
